import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/mapping/field-relation.ts";
import { T } from '@contentlayer/utils/effect';
const isSingle = (databaseFieldTypeDef) => {
    return (databaseFieldTypeDef &&
        'type' in databaseFieldTypeDef &&
        databaseFieldTypeDef.type === 'relation' &&
        databaseFieldTypeDef.single);
};
export const fieldRelation = {
    getFieldDef: ({ databaseFieldTypeDef }) => {
        if (isSingle(databaseFieldTypeDef)) {
            return T.succeed({
                type: 'string',
            }, fileName_1 + ":18:23");
        }
        return T.succeed({
            type: 'list',
            of: { type: 'string' },
            default: [],
        }, fileName_1 + ":23:21");
    },
    getFieldData: ({ propertyData, databaseFieldTypeDef }) => {
        if (isSingle(databaseFieldTypeDef)) {
            return T.succeed(propertyData[0]?.id, fileName_1 + ":31:23");
        }
        return T.succeed(propertyData.map((r) => r.id), fileName_1 + ":34:21");
    },
};
//# sourceMappingURL=field-relation.js.map