import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/notion/fetchNotion.ts";
import PQueue, { AbortError } from 'p-queue';
import pRetry from 'p-retry';
const queue = new PQueue({ interval: 1000, intervalCap: 4 });
export const fetchNotion = (...args) => {
    return queue.add(() => pRetry(async () => {
        const response = await fetch(...args);
        if (!response.ok) {
            throw new AbortError(response.statusText);
        }
        return response;
    }, {
        retries: 5,
        onFailedAttempt: async () => new Promise((res) => setTimeout(res, 1000)),
    }));
};
//# sourceMappingURL=fetchNotion.js.map